package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	/**
	$(CBI)* ...
	$(CBI)* @author Guchan Alkan
	$(CBI)*/
	public class UserInterface extends Sprite
	{
		private var setStartButton:Sprite = new Sprite();
		private var setFinishButton:Sprite = new Sprite();
		private var setObstacleButton:Sprite = new Sprite();
		private var findPathButton:Sprite = new Sprite();
		private var switchButton:Sprite = new Sprite();
		private var switchButtonText:String = "Step by step";
		private var buttonArray:Array;
		private var uiTextField:TextField = new TextField();
		
		public function UserInterface() 
		{
			this.graphics.beginFill(0x000000, .5);
			this.graphics.drawRect(0, 0, 100, 500);
			this.graphics.endFill();
			
			setStartButton = uiButton(0x66CC99, "Set Start");
			setFinishButton = uiButton(0xFFCC00, "Set Finish");
			setObstacleButton = uiButton(0x000000, "Set Obstacle");
			findPathButton = uiButton(0xFF0055, "Find Path");
			switchButton = uiButton(0xFFFFFF, "Switch Type");
			
			buttonArray = new Array(setStartButton, setFinishButton, setObstacleButton, findPathButton, switchButton);
			
			for (var i:int = 0; i < buttonArray.length; i++)
			{
				addChild(buttonArray[i]);
				buttonArray[i].y = i * 30;
				buttonArray[i].getChildAt(1).name = i.toString();
				buttonArray[i].getChildAt(1).addEventListener(MouseEvent.CLICK, onClick);
			}
			
			uiTextField.defaultTextFormat = new TextFormat("Arial", 10, 0x000000, true);
			uiTextField.selectable = false;
			uiTextField.y = 250;
			uiTextField.width = 100;
			uiTextField.wordWrap = true;
			addChild(uiTextField);
		}
		private function onClick(e:MouseEvent):void
		{
			switch (e.target.name) 
			{
				case "0":
					Utilities.nodeType = 0;
				break;
				case "1":
					Utilities.nodeType = 1;
				break;
				case "2":
					Utilities.nodeType = 2;
				break;
				case "3":
					Utilities.main.findPath();
				break;
				case "4":
					switchButtonFunction();
				break;
			}
		}
		public function setTextField(dataString:String):void
		{
			uiTextField.text = dataString;
		}
		private function switchButtonFunction():void
		{
			if (Utilities.instantSimulation)
			{
				Utilities.instantSimulation = false;
				setTextField("Simulation Mode: Step by Step");
			}
			else
			{
				Utilities.instantSimulation = true;
				setTextField("Simulation Mode: Instant");
			}
		}
		private function uiButton(color:int, label:String):Sprite
		{
			var baseLayer:Sprite = new Sprite();
			baseLayer.graphics.beginFill(color);
			baseLayer.graphics.drawRect(0, 0, 28, 28);
			baseLayer.graphics.endFill();
			
			var buttonLabel:TextField = new TextField();
			buttonLabel.autoSize = "left";
			buttonLabel.selectable = false;
			buttonLabel.defaultTextFormat = new TextFormat("Arial", 10, 0xFFFFFF, true);
			buttonLabel.text = label;
			buttonLabel.x = 30;
			baseLayer.addChild(buttonLabel);
			
			var buttonLayer:Sprite = new Sprite();
			buttonLayer.graphics.beginFill(0x000000, 0);
			buttonLayer.graphics.drawRect(0, 0, 28, 28);
			buttonLayer.graphics.endFill();
			buttonLayer.buttonMode = true;
			baseLayer.addChild(buttonLayer);
			
			return baseLayer;
		}
	}

}